// Copyright Notice
// ================
// BOCHS is Copyright 1994-1999 by Kevin P. Lawton.
//
// BOCHS is commercial software.
//
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
//
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02452-3028
//
//     EMail:    bochs@world.std.com



#include "bochs.h"


// Nomenclature used to signify argument types
//
// Es = single real
// El = double real
// Ea = 14/28 bytes    98/108b bytes (FRSTOR,FSAVE)???
// Ew = word integer (2 bytes)
// Ed = dword integer (4 bytes) (short int)
// Et = extended real
// Eb = packed BCD
// Eq = quadword integer (8 bytes) (long integer)




// A few NDP instructions are defined here to do nothing.  This
// is a minimal set of instructions that software has used
// to determine there is no floating point unit.  The remaining
// instructions are unimplemented and cause a panic().


  void
BX_CPU_C::ESC0(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC0 not implemented\n");
}

  void
BX_CPU_C::ESC1(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC1 not implemented\n");
}

  void
BX_CPU_C::ESC2(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC2 not implemented\n");
}

  void
BX_CPU_C::ESC3(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC3 not implemented\n");
}

  void
BX_CPU_C::ESC4(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC4 not implemented\n");
}

  void
BX_CPU_C::ESC5(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC5 not implemented\n");
}

  void
BX_CPU_C::ESC6(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC6 not implemented\n");
}

  void
BX_CPU_C::ESC7(BxInstruction_t *i)
{
  if ( BX_CPU_THIS_PTR cr0.em || BX_CPU_THIS_PTR cr0.ts ) {
    exception(BX_NM_EXCEPTION, 0, 0);
    }
  bx_printf("ESC7 not implemented\n");
}


  void
BX_CPU_C::FSTCW_Ew(BxInstruction_t *i)
{
}

  INLINE void
BX_CPU_C::FNOP(BxInstruction_t *i)
{
}

  INLINE void
BX_CPU_C::FCLEX(BxInstruction_t *i)
{
  bx_printf("FCLEX: called, but no action taken.\n");
}

  INLINE void
BX_CPU_C::FINIT(BxInstruction_t *i)
{
}

  INLINE void
BX_CPU_C::FSETPM(BxInstruction_t *i)
{
}

  INLINE void
BX_CPU_C::FSTSW_Ew(BxInstruction_t *i)
{
}

  INLINE void
BX_CPU_C::FSTSW_AX(BxInstruction_t *i)
{
}


INLINE void BX_CPU_C::FADD_Es(BxInstruction_t *i) {bx_panic("FADD?:\n");}
INLINE void BX_CPU_C::FMUL_Es(BxInstruction_t *i) {bx_panic("FMUL?:\n");}
INLINE void BX_CPU_C::FCOM_Es(BxInstruction_t *i) {bx_panic("FCOM?:\n");}
INLINE void BX_CPU_C::FCOMP_Es(BxInstruction_t *i) {bx_panic("FCOMP?:\n");}
INLINE void BX_CPU_C::FSUB_Es(BxInstruction_t *i) {bx_panic("FSUB?:\n");}
INLINE void BX_CPU_C::FSUBR_Es(BxInstruction_t *i) {bx_panic("FSUBR?:\n");}
INLINE void BX_CPU_C::FDIV_Es(BxInstruction_t *i) {bx_panic("FDIV?:\n");}
INLINE void BX_CPU_C::FDIVR_Es(BxInstruction_t *i) {bx_panic("FDIVR?:\n");}
INLINE void BX_CPU_C::FADD_ST_STi(BxInstruction_t *i) {bx_panic("FADD?:\n");}
INLINE void BX_CPU_C::FMUL_ST_STi(BxInstruction_t *i) {bx_panic("FMUL?:\n");}
INLINE void BX_CPU_C::FCOM_ST_STi(BxInstruction_t *i) {bx_panic("FCOM?:\n");}
INLINE void BX_CPU_C::FCOMP_ST_STi(BxInstruction_t *i) {bx_panic("FCOMP?:\n");}
INLINE void BX_CPU_C::FSUB_ST_STi(BxInstruction_t *i) {bx_panic("FSUB?:\n");}
INLINE void BX_CPU_C::FSUBR_ST_STi(BxInstruction_t *i) {bx_panic("FSUBR?:\n");}
INLINE void BX_CPU_C::FDIV_ST_STi(BxInstruction_t *i) {bx_panic("FDIV?:\n");}
INLINE void BX_CPU_C::FDIVR_ST_STi(BxInstruction_t *i) {bx_panic("FDIVR?:\n");}
INLINE void BX_CPU_C::FLD_STi(BxInstruction_t *i) {bx_panic("FLD?:\n");}
INLINE void BX_CPU_C::FXCH_STi(BxInstruction_t *i) {bx_panic("FXCH?:\n");}
INLINE void BX_CPU_C::FLD_Es(BxInstruction_t *i) {bx_panic("FLD?:\n");}
INLINE void BX_CPU_C::FST_Es(BxInstruction_t *i) {bx_panic("FST?:\n");}
INLINE void BX_CPU_C::FSTP_Es(BxInstruction_t *i) {bx_panic("FSTP?:\n");}
INLINE void BX_CPU_C::FLDENV_Ea(BxInstruction_t *i) {bx_panic("FLDENV?:\n");}
INLINE void BX_CPU_C::FLDCW_Ew(BxInstruction_t *i) {bx_panic("FLDCW?:\n");}
INLINE void BX_CPU_C::FSTENV_Ea(BxInstruction_t *i) {bx_panic("FSTENV?:\n");}
INLINE void BX_CPU_C::FCHS(BxInstruction_t *i) {bx_panic("FCHS?:\n");}
INLINE void BX_CPU_C::FLD1(BxInstruction_t *i) {bx_panic("FLD1?:\n");}
INLINE void BX_CPU_C::F2XM1(BxInstruction_t *i) {bx_panic("F2XM1?:\n");}
INLINE void BX_CPU_C::FPREM(BxInstruction_t *i) {bx_panic("FPREM?:\n");}
INLINE void BX_CPU_C::FABS(BxInstruction_t *i) {bx_panic("FABS?:\n");}
INLINE void BX_CPU_C::FLDL2T(BxInstruction_t *i) {bx_panic("FLDL2T?:\n");}
INLINE void BX_CPU_C::FYL2X(BxInstruction_t *i) {bx_panic("FYL2X?:\n");}
INLINE void BX_CPU_C::FYL2XP1(BxInstruction_t *i) {bx_panic("FYL2XP1?:\n");}
INLINE void BX_CPU_C::FLDL2E(BxInstruction_t *i) {bx_panic("FLDL2E?:\n");}
INLINE void BX_CPU_C::FPTAN(BxInstruction_t *i) {bx_panic("FPTAN?:\n");}
INLINE void BX_CPU_C::FSQRT(BxInstruction_t *i) {bx_panic("FSQRT?:\n");}
INLINE void BX_CPU_C::FXCH_3(BxInstruction_t *i) {bx_panic("FXCH?:\n");}
INLINE void BX_CPU_C::FLDPI(BxInstruction_t *i) {bx_panic("FLDPI?:\n");}
INLINE void BX_CPU_C::FPATAN(BxInstruction_t *i) {bx_panic("FPATAN?:\n");}
INLINE void BX_CPU_C::FSINCOS(BxInstruction_t *i) {bx_panic("FSINCOS?:\n");}
INLINE void BX_CPU_C::FTST(BxInstruction_t *i) {bx_panic("FTST?:\n");}
INLINE void BX_CPU_C::FLDLG2(BxInstruction_t *i) {bx_panic("FLDLG2?:\n");}
INLINE void BX_CPU_C::FXTRACT(BxInstruction_t *i) {bx_panic("FXTRACT?:\n");}
INLINE void BX_CPU_C::FRNDINT(BxInstruction_t *i) {bx_panic("FRNDINT?:\n");}
INLINE void BX_CPU_C::FXAM(BxInstruction_t *i) {bx_panic("FXAM?:\n");}
INLINE void BX_CPU_C::FLDLN2(BxInstruction_t *i) {bx_panic("FLDLN2?:\n");}
INLINE void BX_CPU_C::FPREM1(BxInstruction_t *i) {bx_panic("FPREM1?:\n");}
INLINE void BX_CPU_C::FSCALE(BxInstruction_t *i) {bx_panic("FSCALE?:\n");}
INLINE void BX_CPU_C::FLDZ(BxInstruction_t *i) {bx_panic("FLDZ?:\n");}
INLINE void BX_CPU_C::FDECSTP(BxInstruction_t *i) {bx_panic("FDECSTP?:\n");}
INLINE void BX_CPU_C::FSIN(BxInstruction_t *i) {bx_panic("FSIN?:\n");}
INLINE void BX_CPU_C::FINCSTP(BxInstruction_t *i) {bx_panic("FINCSTP?:\n");}
INLINE void BX_CPU_C::FCOS(BxInstruction_t *i) {bx_panic("FCOS?:\n");}
INLINE void BX_CPU_C::FIADD_Ew(BxInstruction_t *i) {bx_panic("FIADD?:\n");}
INLINE void BX_CPU_C::FIMUL_Ew(BxInstruction_t *i) {bx_panic("FIMUL?:\n");}
INLINE void BX_CPU_C::FICOM_Ew(BxInstruction_t *i) {bx_panic("FICOM?:\n");}
INLINE void BX_CPU_C::FICOMP_Ew(BxInstruction_t *i) {bx_panic("FICOMP?:\n");}
INLINE void BX_CPU_C::FISUB_Ew(BxInstruction_t *i) {bx_panic("FISUB?:\n");}
INLINE void BX_CPU_C::FISUBR_Ew(BxInstruction_t *i) {bx_panic("FISUBR?:\n");}
INLINE void BX_CPU_C::FIDIV_Ew(BxInstruction_t *i) {bx_panic("FIDIV?:\n");}
INLINE void BX_CPU_C::FIDIVR_Ew(BxInstruction_t *i) {bx_panic("FIDIVR?:\n");}
INLINE void BX_CPU_C::FUCOMPP(BxInstruction_t *i) {bx_panic("FUCOMPP?:\n");}
INLINE void BX_CPU_C::FILD_Ew(BxInstruction_t *i) {bx_panic("FILD?:\n");}
INLINE void BX_CPU_C::FIST_Ew(BxInstruction_t *i) {bx_panic("FIST?:\n");}
INLINE void BX_CPU_C::FISTP_Ew(BxInstruction_t *i) {bx_panic("FISTP?:\n");}
INLINE void BX_CPU_C::FLD_Et(BxInstruction_t *i) {bx_panic("FLD?:\n");}
INLINE void BX_CPU_C::FSTP_Et(BxInstruction_t *i) {bx_panic("FSTP?:\n");}
INLINE void BX_CPU_C::FENI(BxInstruction_t *i) {bx_panic("FENI?:\n");}
INLINE void BX_CPU_C::FDISI(BxInstruction_t *i) {bx_panic("FDISI?:\n");}
INLINE void BX_CPU_C::FADD_El(BxInstruction_t *i) {bx_panic("FADD?:\n");}
INLINE void BX_CPU_C::FMUL_El(BxInstruction_t *i) {bx_panic("FMUL?:\n");}
INLINE void BX_CPU_C::FCOM_El(BxInstruction_t *i) {bx_panic("FCOM?:\n");}
INLINE void BX_CPU_C::FCOMP_El(BxInstruction_t *i) {bx_panic("FCOMP?:\n");}
INLINE void BX_CPU_C::FSUB_El(BxInstruction_t *i) {bx_panic("FSUB?:\n");}
INLINE void BX_CPU_C::FSUBR_El(BxInstruction_t *i) {bx_panic("FSUBR?:\n");}
INLINE void BX_CPU_C::FDIV_El(BxInstruction_t *i) {bx_panic("FDIV?:\n");}
INLINE void BX_CPU_C::FDIVR_El(BxInstruction_t *i) {bx_panic("FDIVR?:\n");}
INLINE void BX_CPU_C::FADD_STi_ST(BxInstruction_t *i) {bx_panic("FADD?:\n");}
INLINE void BX_CPU_C::FMUL_STi_ST(BxInstruction_t *i) {bx_panic("FMUL?:\n");}
INLINE void BX_CPU_C::FSUB_STi_ST(BxInstruction_t *i) {bx_panic("FSUB?:\n");}
INLINE void BX_CPU_C::FSUBR_STi_ST(BxInstruction_t *i) {bx_panic("FSUBR?:\n");}
INLINE void BX_CPU_C::FDIV_STi_ST(BxInstruction_t *i) {bx_panic("FDIV?:\n");}
INLINE void BX_CPU_C::FDIVR_STi_ST(BxInstruction_t *i) {bx_panic("FDIVR:\n");}
INLINE void BX_CPU_C::FLD_El(BxInstruction_t *i) {bx_panic("FLD?:\n");}
INLINE void BX_CPU_C::FST_El(BxInstruction_t *i) {bx_panic("FST?:\n");}
INLINE void BX_CPU_C::FSTP_El(BxInstruction_t *i) {bx_panic("FSTP?:\n");}
INLINE void BX_CPU_C::FRSTOR_Ea(BxInstruction_t *i) {bx_panic("FRSTOR?:\n");}
INLINE void BX_CPU_C::FSAVE_Ea(BxInstruction_t *i) {bx_panic("FSAVE?:\n");}
INLINE void BX_CPU_C::FFREE_STi(BxInstruction_t *i) {bx_panic("FFREE?:\n");}
INLINE void BX_CPU_C::FST_STi(BxInstruction_t *i) {bx_panic("FST?:\n");}
INLINE void BX_CPU_C::FSTP_STi(BxInstruction_t *i) {bx_panic("FSTP?:\n");}
INLINE void BX_CPU_C::FUCOM_STi_ST(BxInstruction_t *i) {bx_panic("FUCOM?:\n");}
INLINE void BX_CPU_C::FUCOMP_STi(BxInstruction_t *i) {bx_panic("FUCOMP?:\n");}
INLINE void BX_CPU_C::FIADD_Ed(BxInstruction_t *i) {bx_panic("FIADD?:\n");}
INLINE void BX_CPU_C::FIMUL_Ed(BxInstruction_t *i) {bx_panic("FIMUL?:\n");}
INLINE void BX_CPU_C::FICOM_Ed(BxInstruction_t *i) {bx_panic("FICOM?:\n");}
INLINE void BX_CPU_C::FICOMP_Ed(BxInstruction_t *i) {bx_panic("FICOMP?:\n");}
INLINE void BX_CPU_C::FISUB_Ed(BxInstruction_t *i) {bx_panic("FISUB?:\n");}
INLINE void BX_CPU_C::FISUBR_Ed(BxInstruction_t *i) {bx_panic("FISUBR?:\n");}
INLINE void BX_CPU_C::FIDIV_Ed(BxInstruction_t *i) {bx_panic("FIDIV?:\n");}
INLINE void BX_CPU_C::FIDIVR_Ed(BxInstruction_t *i) {bx_panic("FIDIVR?:\n");}
INLINE void BX_CPU_C::FADDP_STi_ST(BxInstruction_t *i) {bx_panic("FADDP?:\n");}
INLINE void BX_CPU_C::FMULP_STi_ST(BxInstruction_t *i) {bx_panic("FMULP?:\n");}
INLINE void BX_CPU_C::FCOMPP(BxInstruction_t *i) {bx_panic("FCOMPP?:\n");}
INLINE void BX_CPU_C::FSUBP_STi_ST(BxInstruction_t *i) {bx_panic("FSUBP?:\n");}
INLINE void BX_CPU_C::FSUBRP_STi_ST(BxInstruction_t *i) {bx_panic("FSUBRP?:\n");}
INLINE void BX_CPU_C::FDIVP_STi_ST(BxInstruction_t *i) {bx_panic("FDIV?:\n");}
INLINE void BX_CPU_C::FDIVRP_STi_ST(BxInstruction_t *i) {bx_panic("FDIVRP?:\n");}
INLINE void BX_CPU_C::FILD_Ed(BxInstruction_t *i) {bx_panic("FILD_Ed\n");}
INLINE void BX_CPU_C::FIST_Ed(BxInstruction_t *i) {bx_panic("FIST:\n");}
INLINE void BX_CPU_C::FISTP_Ed(BxInstruction_t *i) {bx_panic("FISTP?:\n");}
INLINE void BX_CPU_C::FBLD_Eb(BxInstruction_t *i) {bx_panic("FBLD?:\n");}
INLINE void BX_CPU_C::FILD_Eq(BxInstruction_t *i) {bx_panic("FILD?:\n");}
INLINE void BX_CPU_C::FBSTP_Eb(BxInstruction_t *i) {bx_panic("FBSTP?:\n");}
INLINE void BX_CPU_C::FISTP_Eq(BxInstruction_t *i) {bx_panic("FISTP?:\n");}
INLINE void BX_CPU_C::FCMOVB_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVB\n");}
INLINE void BX_CPU_C::FCMOVE_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVE\n");}
INLINE void BX_CPU_C::FCMOVBE_ST_STi(BxInstruction_t *i) {bx_panic("FCMOVBE\n");}
INLINE void BX_CPU_C::FCMOVU_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVU\n");}
INLINE void BX_CPU_C::FCMOVNB_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVNB\n");}
INLINE void BX_CPU_C::FCMOVNE_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVNE\n");}
INLINE void BX_CPU_C::FCMOVNBE_ST_STi(BxInstruction_t *i) {bx_panic("FCMOVNBE\n");}
INLINE void BX_CPU_C::FCMOVNU_ST_STi(BxInstruction_t *i)  {bx_panic("FCMOVNU\n");}
INLINE void BX_CPU_C::FUCOMI_ST_STi(BxInstruction_t *i)   {bx_panic("FUCOMI\n");}
INLINE void BX_CPU_C::FCOMI_ST_STi(BxInstruction_t *i)    {bx_panic("FCOMI\n");}
INLINE void BX_CPU_C::FCOMIP(BxInstruction_t *i)  {bx_panic("FCOMIP\n");}
INLINE void BX_CPU_C::FUCOMIP(BxInstruction_t *i) {bx_panic("FUCOMIP\n");}
